controllers/OrderController.php
<?php

namespace app\controllers;

use app\api\CartApi;
use app\api\ShopApi;
use app\dto\ApiDto;
use app\models\OrderForm;
use GuzzleHttp;

/**
 * Class OrderController
 */
class OrderController extends \yii\web\Controller
{
    /**
     * @param $quantity
     * @param $id
     */
    public function actionChangeCart($quantity, $id)
    {
        CartApi::add2Cart($id, $quantity);
    }


    public function actionOrder()
    {
        $model = new OrderForm();
        $request = \Yii::$app->request->post('OrderForm');
        if (!empty($request)) {
            $model->attributes = $request;
            $model->goods = (array)CartApi::getCart();
            $api = new ShopApi(new GuzzleHttp\Client(), new ApiDto(\Yii::$app->params['shop']['auth']));
            $result = $api->sendOrder((array)$model);


            if ($model->validate()) {

            }
        }
    }


    public function actionPay($id)
    {
        $api = new ShopApi(new GuzzleHttp\Client(), new ApiDto(\Yii::$app->params['shop']['auth']));
        $result = $api->orderPay($id);
    }
}

controllers/ShopController.php
<?php

namespace app\controllers;

use app\api\ShopApi;
use app\dto\ApiDto;
use app\models\LoginForm;
use app\models\OrderForm;
use GuzzleHttp;
use yii\data\ArrayDataProvider;
use yii\data\Pagination;
use yii\web\Controller;

/**
 * Class ShopController
 * @package app\controllers
 */
class ShopController extends Controller
{

    /**
     * @param mixed $page
     * @return mixed
     */
    public function actionIndex($page = null)
    {

        if (\Yii::$app->user->isGuest == false || 1) {
            $api = new ShopApi(new GuzzleHttp\Client(), new ApiDto(\Yii::$app->params['shop']['auth']));
            $response = $api->getProductList($page);
            $dataProvider = new ArrayDataProvider([
                'allModels' => $response['items'],
                'pagination' => false,
            ]);
            $orderForm = new OrderForm();
            $pages = new Pagination(['totalCount' => $response['_meta']['totalCount']]);

            $result = $this->render('index', compact('dataProvider', 'pages', 'orderForm'));
        } else {
            $model = new LoginForm();
            $request = \Yii::$app->request->post('LoginForm');
            if ($request) {
                $model->attributes = $request;
                $model->login();
            }
            $result = $this->render('login', compact('model'));
        }

        return $result;

    }

    public function actionList($page = null)
    {

        $api = new ShopApi(new GuzzleHttp\Client(), new ApiDto(\Yii::$app->params['shop']['auth']));
        $response = $api->getOrderList($page);

        $dataProvider = new ArrayDataProvider([
            'allModels' => $response['items'],
            'pagination' => false,
        ]);
        return $this->render('list', compact('dataProvider', 'pages'));
    }
}

views/shop/index.php
<?php
/**
 * @var $orderForm app\models\OrderForm
 */

use app\api\CartApi;
use yii\bootstrap4\Modal;
use yii\grid\GridView;
use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\widgets\LinkPager;


echo GridView::widget(
    [
        'dataProvider' => $dataProvider,
        'summary' => '',
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            [
                'attribute' => 'id',
                'label' => 'Код товара',
            ],
            [
                'attribute' => 'car',
                'label' => 'Для авто',
            ],
            [
                'attribute' => 'product',
                'label' => 'Тип детали',
            ],

            [
                'label' => 'Кол-во',
                'attribute' => 'quantity',
                'value' => function ($data) {
                    if (!empty($data['remain'])) {
                        return $data['remain']['quantity'] - $data['remain']['reserve'];
                    }

                },
            ],
            [
                'label' => 'Цена',
                'attribute' => 'price',
                'value' => function ($row) {
                    return number_format($row['price'], 2);
                }
            ],
            [
                'class' => 'yii\grid\ActionColumn',
                'template' => '{add2order}',
                'buttons' => [
                    'add2order' => function ($url, $model, $key) {
                        return Html::input('number', sprintf('cart[%d]', $model['id']), CartApi::getProduct($model['id']), [
                            'onchange' => sprintf('$.get("%s", {quantity: $(this).val(),id:%d});', \yii\helpers\Url::to(['order/change-cart']), $model['id']),
                            'max' => $model['remain']['quantity'] - $model['remain']['reserve'],
                        ]);
                    }
                ]
            ],
        ],
    ]
);

echo LinkPager::widget([
    'pagination' => $pages,
]);
echo Html::tag('br');
echo Html::tag('br');


Modal::begin([
    'title' => 'Создание заказа',
    'toggleButton' => ['label' => 'Оформить'],
]);


$form = ActiveForm::begin([
    'id' => 'order-form',
    'options' => [
        'class' => 'form-horizontal',
        'onsubmit' => '$.post( "' . \yii\helpers\Url::to(['order/order']) . '", $(this).serialize(), function( data ) {console.log(data)});return;'
    ],
]) ?>


<?= $form->field($orderForm, 'name') ?>
<?= $form->field($orderForm, 'email') ?>

<?= Html::submitButton('Заказать', ['class' => 'btn btn-primary']) ?>
<?php
ActiveForm::end();
Modal::end();

?>

views/shop/list.php
<?php


use app\api\ShopApi;
use yii\grid\GridView;
use yii\helpers\Html;


echo GridView::widget(
    [
        'dataProvider' => $dataProvider,
        'summary' => '',
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            [
                'attribute' => 'id',
                'label' => 'Код заказа',
            ],
            [
                'attribute' => 'user',
                'label' => 'Пользователь',
            ],
            [
                'attribute' => 'create_at',
                'label' => 'Дата создания',
            ], [
                'attribute' => 'status',
                'label' => 'Статус заказа',
                'value' => function ($model) {
                    return ShopApi::getOrderStatusName($model['status']);
                }
            ],
            [
                'class' => 'yii\grid\ActionColumn',
                'template' => '{add2order}',
                'buttons' => [
                    'add2order' => function ($url, $model, $key) {
                        if($model['status'] == ShopApi::ORDER_STATUS_NEW || 1){
                            return Html::button('Оплатить', [
                                'onclick' => sprintf('$.get("%s");', \yii\helpers\Url::to(['order/pay','id' => $model['id']])),
                            ]);
                        }
                    }
                ]
            ],
        ],
    ]
); ?>

views/shop/login.php
<?php

/***
 * @var $model app\models\LoginForm
 */

use yii\bootstrap4\ActiveForm;
use yii\helpers\Html;


echo Html::tag('h1', 'Login');

echo Html::endTag('h1');
$form = ActiveForm::begin([
    'id' => 'login-form',
    'layout' => 'horizontal',
    'fieldConfig' => [
        'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
        'labelOptions' => ['class' => 'col-lg-1 col-form-label'],
    ],
]);

echo $form->field($model, 'username')->textInput(['autofocus' => true]);
echo $form->field($model, 'password')->passwordInput();
echo Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']);

ActiveForm::end();